// 005 u_gof_visitor
// 11 dec 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   Felix John COLIBRI  http://www.felix-colibri.com

(*$r+*)

unit u_gof_visitor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    exit_: TButton;
    clear_: TButton;
    display_inventory_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure display_inventory_Click(Sender: TObject);
  private

  public

  end;

    var Form1: TForm1;

  implementation
    uses u_types_constants, u_c_log, u_c_display
        , u_dir, u_file

        , u_c_visitor_23
    ;

    {$R *.DFM}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.display_inventory_Click(Sender: TObject);
      var l_c_component: c_equipment;
          l_c_inventory_visitor: c_inventory_visitor;
      begin
        l_c_component:= c_floppy.create_floppy('3"');
        l_c_inventory_visitor:= c_inventory_visitor.create_inventory_visitor;
        l_c_component.accept(l_c_inventory_visitor);
        display(l_c_component.f_equipment_name
            + ' '+ l_c_inventory_visitor.f_c_inventory.f_display_inventory);
      end; // display_inventory_Click

end.


